Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 782)
+++ inc/admin/lib.pager.php	(revision 860)
@@ -12,12 +12,4 @@
 if (!defined('DC_RC_PATH')) { return; }
 
-/**
-@ingroup DC_CORE
-@nosubgrouping
-@brief Dotclear generic list class.
-@deprecated Please use class adminItemslist to create admin lists
-
-Dotclear generic list handles every admin list.
-*/
 class adminGenericList
 {
@@ -26,17 +18,6 @@
 	protected $rs_count;
 	
-	/**
-	@deprecated Please use class adminItemslist to create admin lists
-	
-	@param	core		<b>dcCore</b>		dcCore object
-	@param	rs		<b>recordSet</b>	Items recordSet to display
-	@param	rs_count	<b>int</b>		Total items number
-	*/
 	public function __construct($core,$rs,$rs_count)
 	{
-		// For backward compatibility only: the developer tried to create
-		// a list with the old constructor.
-		ob_start($this->raiseDeprecated(get_class($this)));
-		
 		$this->core =& $core;
 		$this->rs =& $rs;
@@ -45,23 +26,395 @@
 		$this->html_next = __('next&#187;');
 	}
-	
-	/**
-	Raises a E_USER_NOTICE error for deprecated classes. 
-	This allows the developer to know he's been using deprecated classes.
-	
-	@param	name	<b>string</b>	Name of the deprecated classes that was called.
-	*/
-	private function raiseDeprecated($name)
-	{
-		if (DC_DEBUG) {
-			$trace = debug_backtrace();
-			array_shift($trace);
-			$grand = array_shift($trace);
-			$msg = 'Deprecated class called. (';
-			$msg .= $name.' was called from '.$grand['file'].' ['.$grand['line'].'])';
-			trigger_error($msg, E_USER_NOTICE);
-		}
-	}
 }
 
+class adminPostList extends adminGenericList
+{
+	public function display($page,$nb_per_page,$enclose_block='')
+	{
+		if ($this->rs->isEmpty())
+		{
+			echo '<p><strong>'.__('No entry').'</strong></p>';
+		}
+		else
+		{
+			$pager = new pager($page,$this->rs_count,$nb_per_page,10);
+			$pager->html_prev = $this->html_prev;
+			$pager->html_next = $this->html_next;
+			$pager->var_page = 'page';
+			
+			$html_block =
+			'<table class="clear"><tr>'.
+			'<th colspan="2">'.__('Title').'</th>'.
+			'<th>'.__('Date').'</th>'.
+			'<th>'.__('Category').'</th>'.
+			'<th>'.__('Author').'</th>'.
+			'<th>'.__('Comments').'</th>'.
+			'<th>'.__('Trackbacks').'</th>'.
+			'<th>'.__('Status').'</th>'.
+			'</tr>%s</table>';
+			
+			if ($enclose_block) {
+				$html_block = sprintf($enclose_block,$html_block);
+			}
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			
+			$blocks = explode('%s',$html_block);
+			
+			echo $blocks[0];
+			
+			while ($this->rs->fetch())
+			{
+				echo $this->postLine();
+			}
+			
+			echo $blocks[1];
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		}
+	}
+	
+	private function postLine()
+	{
+		if ($this->core->auth->check('categories',$this->core->blog->id)) {
+			$cat_link = '<a href="category.php?id=%s">%s</a>';
+		} else {
+			$cat_link = '%2$s';
+		}
+		
+		if ($this->rs->cat_title) {
+			$cat_title = sprintf($cat_link,$this->rs->cat_id,
+			html::escapeHTML($this->rs->cat_title));
+		} else {
+			$cat_title = __('None');
+		}
+		
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		switch ($this->rs->post_status) {
+			case 1:
+				$img_status = sprintf($img,__('published'),'check-on.png');
+				break;
+			case 0:
+				$img_status = sprintf($img,__('unpublished'),'check-off.png');
+				break;
+			case -1:
+				$img_status = sprintf($img,__('scheduled'),'scheduled.png');
+				break;
+			case -2:
+				$img_status = sprintf($img,__('pending'),'check-wrn.png');
+				break;
+		}
+		
+		$protected = '';
+		if ($this->rs->post_password) {
+			$protected = sprintf($img,__('protected'),'locker.png');
+		}
+		
+		$selected = '';
+		if ($this->rs->post_selected) {
+			$selected = sprintf($img,__('selected'),'selected.png');
+		}
+		
+		$attach = '';
+		$nb_media = $this->rs->countMedia();
+		if ($nb_media > 0) {
+			$attach_str = $nb_media == 1 ? __('%d attachment') : __('%d attachments');
+			$attach = sprintf($img,sprintf($attach_str,$nb_media),'attach.png');
+		}
+		
+		$res = '<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
+		' id="p'.$this->rs->post_id.'">';
+		
+		$res .=
+		'<td class="nowrap">'.
+		form::checkbox(array('entries[]'),$this->rs->post_id,'','','',!$this->rs->isEditable()).'</td>'.
+		'<td class="maximal"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
+		html::escapeHTML($this->rs->post_title).'</a></td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
+		'<td class="nowrap">'.$cat_title.'</td>'.
+		'<td class="nowrap">'.$this->rs->user_id.'</td>'.
+		'<td class="nowrap">'.$this->rs->nb_comment.'</td>'.
+		'<td class="nowrap">'.$this->rs->nb_trackback.'</td>'.
+		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
+		'</tr>';
+		
+		return $res;
+	}
+}
+
+class adminPostMiniList extends adminGenericList
+{
+	public function display($page,$nb_per_page,$enclose_block='')
+	{
+		if ($this->rs->isEmpty())
+		{
+			echo '<p><strong>'.__('No entry').'</strong></p>';
+		}
+		else
+		{
+			$pager = new pager($page,$this->rs_count,$nb_per_page,10);
+			$pager->html_prev = $this->html_prev;
+			$pager->html_next = $this->html_next;
+			$pager->var_page = 'page';
+			
+			$html_block =
+			'<table class="clear"><tr>'.
+			'<th>'.__('Title').'</th>'.
+			'<th>'.__('Date').'</th>'.
+			'<th>'.__('Author').'</th>'.
+			'<th>'.__('Status').'</th>'.
+			'</tr>%s</table>';
+			
+			if ($enclose_block) {
+				$html_block = sprintf($enclose_block,$html_block);
+			}
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			
+			$blocks = explode('%s',$html_block);
+			
+			echo $blocks[0];
+			
+			while ($this->rs->fetch())
+			{
+				echo $this->postLine();
+			}
+			
+			echo $blocks[1];
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		}
+	}
+	
+	private function postLine()
+	{
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		switch ($this->rs->post_status) {
+			case 1:
+				$img_status = sprintf($img,__('published'),'check-on.png');
+				break;
+			case 0:
+				$img_status = sprintf($img,__('unpublished'),'check-off.png');
+				break;
+			case -1:
+				$img_status = sprintf($img,__('scheduled'),'scheduled.png');
+				break;
+			case -2:
+				$img_status = sprintf($img,__('pending'),'check-wrn.png');
+				break;
+		}
+		
+		$protected = '';
+		if ($this->rs->post_password) {
+			$protected = sprintf($img,__('protected'),'locker.png');
+		}
+		
+		$selected = '';
+		if ($this->rs->post_selected) {
+			$selected = sprintf($img,__('selected'),'selected.png');
+		}
+		
+		$attach = '';
+		$nb_media = $this->rs->countMedia();
+		if ($nb_media > 0) {
+			$attach_str = $nb_media == 1 ? __('%d attachment') : __('%d attachments');
+			$attach = sprintf($img,sprintf($attach_str,$nb_media),'attach.png');
+		}
+		
+		$res = '<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
+		' id="p'.$this->rs->post_id.'">';
+		
+		$res .=
+		'<td class="maximal"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'" '.
+		'title="'.html::escapeHTML($this->rs->getURL()).'">'.
+		html::escapeHTML($this->rs->post_title).'</a></td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
+		'<td class="nowrap">'.$this->rs->user_id.'</td>'.
+		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
+		'</tr>';
+		
+		return $res;
+	}
+}
+
+class adminCommentList extends adminGenericList
+{
+	public function display($page,$nb_per_page,$enclose_block='')
+	{
+		if ($this->rs->isEmpty())
+		{
+			echo '<p><strong>'.__('No comment').'</strong></p>';
+		}
+		else
+		{
+			$pager = new pager($page,$this->rs_count,$nb_per_page,10);
+			$pager->html_prev = $this->html_prev;
+			$pager->html_next = $this->html_next;
+			$pager->var_page = 'page';
+			
+			$html_block =
+			'<table><tr>'.
+			'<th colspan="2">'.__('Title').'</th>'.
+			'<th>'.__('Date').'</th>'.
+			'<th>'.__('Author').'</th>'.
+			'<th>'.__('Type').'</th>'.
+			'<th>'.__('Status').'</th>'.
+			'<th>&nbsp;</th>'.
+			'</tr>%s</table>';
+			
+			if ($enclose_block) {
+				$html_block = sprintf($enclose_block,$html_block);
+			}
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			
+			$blocks = explode('%s',$html_block);
+			
+			echo $blocks[0];
+			
+			while ($this->rs->fetch())
+			{
+				echo $this->commentLine();
+			}
+			
+			echo $blocks[1];
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		}
+	}
+	
+	private function commentLine()
+	{
+		global $author, $status, $sortby, $order, $nb_per_page;
+		
+		$author_url =
+		'comments.php?n='.$nb_per_page.
+		'&amp;status='.$status.
+		'&amp;sortby='.$sortby.
+		'&amp;order='.$order.
+		'&amp;author='.rawurlencode($this->rs->comment_author);
+		
+		$post_url = $this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id);
+		
+		$comment_url = 'comment.php?id='.$this->rs->comment_id;
+		
+		$comment_dt =
+		dt::dt2str($this->core->blog->settings->system->date_format.' - '.
+		$this->core->blog->settings->system->time_format,$this->rs->comment_dt);
+		
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		switch ($this->rs->comment_status) {
+			case 1:
+				$img_status = sprintf($img,__('published'),'check-on.png');
+				break;
+			case 0:
+				$img_status = sprintf($img,__('unpublished'),'check-off.png');
+				break;
+			case -1:
+				$img_status = sprintf($img,__('pending'),'check-wrn.png');
+				break;
+			case -2:
+				$img_status = sprintf($img,__('junk'),'junk.png');
+				break;
+		}
+		
+		$comment_author = html::escapeHTML($this->rs->comment_author);
+		if (mb_strlen($comment_author) > 20) {
+			$comment_author = mb_strcut($comment_author,0,17).'...';
+		}
+		
+		$res = '<tr class="line'.($this->rs->comment_status != 1 ? ' offline' : '').'"'.
+		' id="c'.$this->rs->comment_id.'">';
+		
+		$res .=
+		'<td class="nowrap">'.
+		form::checkbox(array('comments[]'),$this->rs->comment_id,'','','',0).'</td>'.
+		'<td class="maximal"><a href="'.$post_url.'">'.
+		html::escapeHTML($this->rs->post_title).'</a>'.
+		($this->rs->post_type != 'post' ? ' ('.html::escapeHTML($this->rs->post_type).')' : '').'</td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->comment_dt).'</td>'.
+		'<td class="nowrap"><a href="'.$author_url.'">'.$comment_author.'</a></td>'.
+		'<td class="nowrap">'.($this->rs->comment_trackback ? __('trackback') : __('comment')).'</td>'.
+		'<td class="nowrap status">'.$img_status.'</td>'.
+		'<td class="nowrap status"><a href="'.$comment_url.'">'.
+		'<img src="images/edit-mini.png" alt="" title="'.__('Edit this comment').'" /></a></td>';
+		
+		$res .= '</tr>';
+		
+		return $res;
+	}
+}
+
+class adminUserList extends adminGenericList
+{
+	public function display($page,$nb_per_page,$enclose_block='')
+	{
+		if ($this->rs->isEmpty())
+		{
+			echo '<p><strong>'.__('No user').'</strong></p>';
+		}
+		else
+		{
+			$pager = new pager($page,$this->rs_count,$nb_per_page,10);
+			$pager->html_prev = $this->html_prev;
+			$pager->html_next = $this->html_next;
+			$pager->var_page = 'page';
+			
+			$html_block =
+			'<table class="clear"><tr>'.
+			'<th colspan="2">'.__('Username').'</th>'.
+			'<th>'.__('First Name').'</th>'.
+			'<th>'.__('Last Name').'</th>'.
+			'<th>'.__('Display name').'</th>'.
+			'<th class="nowrap">'.__('Entries').'</th>'.
+			'</tr>%s</table>';
+			
+			if ($enclose_block) {
+				$html_block = sprintf($enclose_block,$html_block);
+			}
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			
+			$blocks = explode('%s',$html_block);
+			
+			echo $blocks[0];
+			
+			while ($this->rs->fetch())
+			{
+				echo $this->userLine();
+			}
+			
+			echo $blocks[1];
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		}
+	}
+	
+	private function userLine()
+	{
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		$img_status = '';
+		
+		$p = $this->core->getUserPermissions($this->rs->user_id);
+		
+		if (isset($p[$this->core->blog->id]['p']['admin'])) {
+			$img_status = sprintf($img,__('admin'),'admin.png');
+		}
+		if ($this->rs->user_super) {
+			$img_status = sprintf($img,__('superadmin'),'superadmin.png');
+		}
+		return
+		'<tr class="line">'.
+		'<td class="nowrap">'.form::hidden(array('nb_post[]'),(integer) $this->rs->nb_post).
+		form::checkbox(array('users[]'),$this->rs->user_id).'</td>'.
+		'<td class="maximal"><a href="user.php?id='.$this->rs->user_id.'">'.
+		$this->rs->user_id.'</a>&nbsp;'.$img_status.'</td>'.
+		'<td class="nowrap">'.$this->rs->user_firstname.'</td>'.
+		'<td class="nowrap">'.$this->rs->user_name.'</td>'.
+		'<td class="nowrap">'.$this->rs->user_displayname.'</td>'.
+		'<td class="nowrap"><a href="posts.php?user_id='.$this->rs->user_id.'">'.
+		$this->rs->nb_post.'</a></td>'.
+		'</tr>';
+	}
+}
 ?>
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 692)
+++ inc/admin/prepend.php	(revision 859)
@@ -37,5 +37,5 @@
 function dc_prepare_url($url) {
 
-	$u = str_replace(array('?','&amp;'),array('\?','&'),$url);
+	$u = str_replace(array('?','&amp;','/'),array('\?','&','\\/'),$url);
 	return (!strpos($u,'\?') ? 
 		'/'.$u.'$/' :
@@ -215,4 +215,7 @@
 	}
 	unset($hfiles,$locales_root);
+
+	$core->auth->user_prefs->addWorkspace('interface');
+	$user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
 
 	# Standard favorites
@@ -266,5 +269,6 @@
 	# Menus creation
 	$_menu['Dashboard'] = new dcMenu('dashboard-menu',null);
-	$_menu['Favorites'] = new dcMenu('favorites-menu','My favorites');
+	if (!$user_ui_nofavmenu)
+		$_menu['Favorites'] = new dcMenu('favorites-menu','My favorites');
 	$_menu['Blog'] = new dcMenu('blog-menu','Blog');
 	$_menu['System'] = new dcMenu('system-menu','System');
@@ -282,5 +286,6 @@
 	$_menu['Blog']->title = __('Blog');
 	$_menu['Plugins']->title = __('Plugins');
-	$_menu['Favorites']->title = __('My favorites');
+	if (!$user_ui_nofavmenu)
+		$_menu['Favorites']->title = __('My favorites');
 
 /*	
@@ -333,36 +338,38 @@
 		$core->auth->check('usage,contentadmin',$core->blog->id) && $core->auth->blog_count > 1);
 
-	// Set favorites menu
-	$ws = $core->auth->user_prefs->addWorkspace('favorites');
-	$count = 0;
-	foreach ($ws->dumpPrefs() as $k => $v) {
-		// User favorites only
-		if (!$v['global']) {
-			$fav = unserialize($v['value']);
-			if (dc_valid_fav($fav['url'])) {
-				$count++;
-				$_menu['Favorites']->addItem(__($fav['title']),$fav['url'],$fav['small-icon'],
-					preg_match(dc_prepare_url($fav['url']),$_SERVER['REQUEST_URI']),
-					(($fav['permissions'] == '*') || $core->auth->check($fav['permissions'],$core->blog->id)),$fav['id'],$fav['class']);
-			}
-		}
-	}	
-	if (!$count) {
-		// Global favorites if any
+	if (!$user_ui_nofavmenu) {
+		// Set favorites menu
+		$ws = $core->auth->user_prefs->addWorkspace('favorites');
+		$count = 0;
 		foreach ($ws->dumpPrefs() as $k => $v) {
-			$fav = unserialize($v['value']);
-			if (dc_valid_fav($fav['url'])) {
-				$count++;
-				$_menu['Favorites']->addItem(__($fav['title']),$fav['url'],$fav['small-icon'],
-					preg_match(dc_prepare_url($fav['url']),$_SERVER['REQUEST_URI']),
-					(($fav['permissions'] == '*') || $core->auth->check($fav['permissions'],$core->blog->id)),$fav['id'],$fav['class']);
-			}
-		}
-	}
-	if (!$count) {
-		// No user or global favorites, add "new entry" fav
-		$_menu['Favorites']->addItem(__('New entry'),'post.php','images/menu/edit.png',
-			preg_match('/post.php$/',$_SERVER['REQUEST_URI']),
-			$core->auth->check('usage,contentadmin',$core->blog->id),'menu-new-post',null);
+			// User favorites only
+			if (!$v['global']) {
+				$fav = unserialize($v['value']);
+				if (dc_valid_fav($fav['url'])) {
+					$count++;
+					$_menu['Favorites']->addItem(__($fav['title']),$fav['url'],$fav['small-icon'],
+						preg_match(dc_prepare_url($fav['url']),$_SERVER['REQUEST_URI']),
+						(($fav['permissions'] == '*') || $core->auth->check($fav['permissions'],$core->blog->id)),$fav['id'],$fav['class']);
+				}
+			}
+		}	
+		if (!$count) {
+			// Global favorites if any
+			foreach ($ws->dumpPrefs() as $k => $v) {
+				$fav = unserialize($v['value']);
+				if (dc_valid_fav($fav['url'])) {
+					$count++;
+					$_menu['Favorites']->addItem(__($fav['title']),$fav['url'],$fav['small-icon'],
+						preg_match(dc_prepare_url($fav['url']),$_SERVER['REQUEST_URI']),
+						(($fav['permissions'] == '*') || $core->auth->check($fav['permissions'],$core->blog->id)),$fav['id'],$fav['class']);
+				}
+			}
+		}
+		if (!$count) {
+			// No user or global favorites, add "new entry" fav
+			$_menu['Favorites']->addItem(__('New entry'),'post.php','images/menu/edit.png',
+				preg_match('/post.php$/',$_SERVER['REQUEST_URI']),
+				$core->auth->check('usage,contentadmin',$core->blog->id),'menu-new-post',null);
+		}
 	}
 }
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 782)
+++ inc/core/class.dc.blog.php	(revision 836)
@@ -106,22 +106,4 @@
 	}
 	
-	/**
-	Returns sql statement for a given parameter. 
-	Computes in() or not_in lists in parameter
-
-	@param	params	<b>array</b> query parameters
-	@param	param_name	<b>array</b> parameter to check
-	@param	sql column	<b>array</b> sql column matching parameter name
-	
-	@return	<b>string</b> the generated SQL statement
-	*/
-	protected function getInParamStr($params, $param_name, $sql_column) {
-		$not='';
-		if (isset($params[$param_name.'_not'])) {
-			$not = "NOT ";
-		}
-		return $sql_column.' '.$not.$this->con->in($params[$param_name]).' ';
-	}
-	
 	/// @name Common public methods
 	//@{
@@ -335,5 +317,5 @@
 		
 		# We need to apply filter after counting
-		if (!empty($params['cat_id']))
+		if (isset($params['cat_id']) && $params['cat_id'] !== '')
 		{
 			$found = false;
@@ -350,5 +332,6 @@
 		}
 		
-		if (!empty($params['cat_url']) && empty($params['cat_id']))
+		if (isset($params['cat_url']) && ($params['cat_url'] !== '') 
+			&& !isset($params['cat_id']))
 		{
 			$found = false;
@@ -597,5 +580,5 @@
 	{
 		if (!$this->core->auth->check('categories',$this->id)) {
-			throw new Exception(__('You are not allowed to delete categories'));
+			throw new Exception(__('You are not allowed to reset categories order'));
 		}
 		
@@ -687,4 +670,8 @@
 	public function getPosts($params=array(),$count_only=false)
 	{
+		# --BEHAVIOR-- coreBlogBeforeGetPosts
+		$params = new ArrayObject($params);
+		$this->core->callBehavior('coreBlogBeforeGetPosts',$params);
+
 		if ($count_only)
 		{
@@ -759,5 +746,5 @@
 		}
 		
-		if (!empty($params['post_id'])) {
+		if (isset($params['post_id']) && $params['post_id'] !== '') {
 			if (is_array($params['post_id'])) {
 				array_walk($params['post_id'],create_function('&$v,$k','if($v!==null){$v=(integer)$v;}'));
@@ -768,13 +755,13 @@
 		}
 		
-		if (!empty($params['post_url'])) {
+		if (isset($params['post_url']) && $params['post_url'] !== '') {
 			$strReq .= "AND post_url = '".$this->con->escape($params['post_url'])."' ";
 		}
 		
 		if (!empty($params['user_id'])) {
-			$strReq .= 'AND '.$this->getInParamStr($params,'user_id','U.user_id');
-		}
-		
-		if (!empty($params['cat_id']))
+			$strReq .= "AND U.user_id = '".$this->con->escape($params['user_id'])."' ";
+		}
+		
+		if (isset($params['cat_id']) && $params['cat_id'] !== '')
 		{
 			if (!is_array($params['cat_id'])) {
@@ -786,5 +773,5 @@
 			$strReq .= 'AND '.$this->getPostsCategoryFilter($params['cat_id'],'cat_id').' ';
 		}
-		elseif (!empty($params['cat_url']))
+		elseif (isset($params['cat_url']) && $params['cat_url'] !== '')
 		{
 			if (!is_array($params['cat_url'])) {
@@ -799,5 +786,5 @@
 		/* Other filters */
 		if (isset($params['post_status'])) {
-			$strReq .= 'AND '.$this->getInParamStr($params,'post_status','post_status');
+			$strReq .= 'AND post_status = '.(integer) $params['post_status'].' ';
 		}
 		
@@ -822,5 +809,5 @@
 		
 		if (!empty($params['post_lang'])) {
-			$strReq .= 'AND '.$this->getInParamStr($params,'post_lang','P.post_lang');
+			$strReq .= "AND P.post_lang = '".$this->con->escape($params['post_lang'])."' ";
 		}
 		
@@ -1023,8 +1010,8 @@
 		$cat_field = $catReq = $limit = '';
 		
-		if (!empty($params['cat_id'])) {
+		if (isset($params['cat_id']) && $params['cat_id'] !== '') {
 			$catReq = 'AND P.cat_id = '.(integer) $params['cat_id'].' ';
 			$cat_field = ', C.cat_url ';
-		} elseif (!empty($params['cat_url'])) {
+		} elseif (isset($params['cat_url']) && $params['cat_url'] !== '') {
 			$catReq = "AND C.cat_url = '".$this->con->escape($params['cat_url'])."' ";
 			$cat_field = ', C.cat_url ';
@@ -1406,6 +1393,6 @@
 		
 		$now = dt::toUTC(time());
-		$to_change = array();
-		
+		$to_change = new ArrayObject();
+
 		if ($rs->isEmpty()) {
 			return;
@@ -1425,16 +1412,21 @@
 			}
 		}
-		
-		if (!empty($to_change))
-		{
+		if (count($to_change))
+		{
+			# --BEHAVIOR-- coreBeforeScheduledEntriesPublish
+			$this->core->callBehavior('coreBeforeScheduledEntriesPublish',$this,$to_change);
+
 			$strReq =
 			'UPDATE '.$this->prefix.'post SET '.
 			'post_status = 1 '.
 			"WHERE blog_id = '".$this->con->escape($this->id)."' ".
-			'AND post_id '.$this->con->in($to_change).' ';
-			
+			'AND post_id '.$this->con->in((array)$to_change).' ';
 			$this->con->execute($strReq);
 			$this->triggerBlog();
-		}
+
+			# --BEHAVIOR-- coreAfterScheduledEntriesPublish
+			$this->core->callBehavior('coreAfterScheduledEntriesPublish',$this,$to_change);
+		}
+		
 	}
 	
@@ -1465,4 +1457,5 @@
 	{
 		$field = $field == 'cat_id' ? 'cat_id' : 'cat_url';
+		
 		$sub = array();
 		$not = array();
@@ -1478,11 +1471,7 @@
 			if (isset($args['not'])) { $not[$id] = 1; }
 			if (isset($args['sub'])) { $sub[$id] = 1; }
-			$nullExcluded = false;
 			if ($field == 'cat_id') {
 				if (preg_match('/^null$/i',$id)) {
 					$queries[$id] = 'P.cat_id IS NULL';
-					if (isset($not[$id]) && ($not[$id] == 1)) {
-						$nullExcluded = true;
-					}
 				}
 				else {
@@ -1526,12 +1515,9 @@
 		
 		if ($sql[1]) {
-			if ($nullExcluded) {
-				$sql[1] = 'NOT('.$sql[1].')';
-			} else {
-				$sql[1] = '(P.cat_id IS NULL OR NOT('.$sql[1].'))';
-			}
+			$sql[1] = '(P.cat_id IS NULL OR NOT('.$sql[1].'))';
 		} else {
 			unset($sql[1]);
 		}
+		
 		return implode(' AND ',$sql);
 	}
@@ -1819,20 +1805,21 @@
 		}
 		
-		if (!empty($params['post_id'])) {
+		if (isset($params['post_id']) && $params['post_id'] !== '') {
 			$strReq .= 'AND P.post_id = '.(integer) $params['post_id'].' ';
 		}
 		
-		if (!empty($params['cat_id'])) {
+		if (isset($params['cat_id']) && $params['cat_id'] !== '') {
 			$strReq .= 'AND P.cat_id = '.(integer) $params['cat_id'].' ';
 		}
 		
-		if (!empty($params['comment_id'])) {
+		if (isset($params['comment_id']) && $params['comment_id'] !== '') {
 			$strReq .= 'AND comment_id = '.(integer) $params['comment_id'].' ';
 		}
 		
 		if (isset($params['comment_status'])) {
-			$strReq .= 'AND '.$this->getInParamStr($params,'comment_status','comment_status');
-		} 
-		elseif (!empty($params['comment_status_not'])) // older method, deprecated
+			$strReq .= 'AND comment_status = '.(integer) $params['comment_status'].' ';
+		}
+		
+		if (!empty($params['comment_status_not']))
 		{
 			$strReq .= 'AND comment_status <> '.(integer) $params['comment_status_not'].' ';
@@ -1850,7 +1837,4 @@
 			$q_author = $this->con->escape(str_replace('*','%',strtolower($params['q_author'])));
 			$strReq .= "AND LOWER(comment_author) LIKE '".$q_author."' ";
-		}
-		if (isset($params['comment_author'])) {
-			$strReq .= "AND comment_author ".$this->con->in($params['comment_author']).' ';
 		}
 		
Index: inc/dbschema/upgrade-cli.php
===================================================================
--- inc/dbschema/upgrade-cli.php	(revision 270)
+++ inc/dbschema/upgrade-cli.php	(revision 838)
@@ -36,5 +36,5 @@
 	$core->con->begin();
 	try {
-		$changes = dotclearUpgrade(&$core);
+		$changes = dotclearUpgrade($core);
 	} catch (Exception $e) {
 		$core->con->rollback();
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 782)
+++ inc/prepend.php	(revision 801)
@@ -55,16 +55,8 @@
 $__autoload['dcPage']				= dirname(__FILE__).'/admin/lib.dc.page.php';
 $__autoload['adminGenericList']		= dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminItemsList']			= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminPostList']			= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminPostMiniList']		= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminCommentList']		= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminUserList']			= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminBlogList']			= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['adminBlogPermissionsList']	= dirname(__FILE__).'/admin/class.dc.list.php';
-$__autoload['dcFilterSet']			= dirname(__FILE__).'/admin/class.dc.filter.php';
-$__autoload['dcFilter']				= dirname(__FILE__).'/admin/class.dc.filter.php';
-$__autoload['textFilter']				= dirname(__FILE__).'/admin/class.dc.filter.php';
-$__autoload['comboFilter']				= dirname(__FILE__).'/admin/class.dc.filter.php';
-$__autoload['dcFilterExtraInterface']				= dirname(__FILE__).'/admin/class.dc.filter.php';
+$__autoload['adminPostList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminPostMiniList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminCommentList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminUserList']			= dirname(__FILE__).'/admin/lib.pager.php';
 
 $__autoload['dcTemplate']			= dirname(__FILE__).'/public/class.dc.template.php';
@@ -131,5 +123,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.4.0');
+define('DC_VERSION','2.5-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 779)
+++ inc/public/class.dc.template.php	(revision 863)
@@ -572,5 +572,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","Archives", $attr,$content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Archives","method" => "blog::getDates"), 
+			$attr,$content);
 		$res .= '$_ctx->archives = $core->blog->getDates($params); unset($params);'."\n";
 		$res .= "?>\n";
@@ -680,5 +682,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","ArchiveNext", $attr, $content);
+		$res .= $this->core->callBehavior("templatePrepareParams",
+			array("tag" => "ArchiveNext","method" => "blog::getDates"), 
+			$attr, $content);
 		$res .= '$_ctx->archives = $core->blog->getDates($params); unset($params);'."\n";
 		$res .= "?>\n";
@@ -717,5 +721,7 @@
 		
 		$res = "<?php\n";
-		$res .= $this->core->callBehavior("templatePrepareParams","ArchivePrevious", $attr, $content);
+		$res .= $this->core->callBehavior("templatePrepareParams",
+			array("tag" => "ArchivePrevious","method" => "blog::getDates"), 
+			$attr, $content);
 		$res .= $p;
 		$res .= '$_ctx->archives = $core->blog->getDates($params); unset($params);'."\n";
@@ -940,5 +946,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","Categories", $attr, $content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Categories","method" => "blog::getCategories"), 
+			$attr,$content);
 		$res .= '$_ctx->categories = $core->blog->getCategories($params);'."\n";
 		$res .= "?>\n";
@@ -1210,5 +1218,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","Entries",$attr,$content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Entries","method" => "blog::getPosts"), 
+			$attr,$content);
 		$res .= '$_ctx->post_params = $params;'."\n";
 		$res .= '$_ctx->posts = $core->blog->getPosts($params); unset($params);'."\n";
@@ -1880,5 +1890,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","Languages",$attr,$content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Languages","method" => "blog::getLangs"), 
+			$attr,$content);
 		$res .= '$_ctx->langs = $core->blog->getLangs($params); unset($params);'."\n";
 		$res .= "?>\n";
@@ -1955,4 +1967,7 @@
 		$p = "<?php\n";
 		$p .= '$params = $_ctx->post_params;'."\n";
+		$p .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Pagination","method" => "blog::getPosts"), 
+			$attr,$content);
 		$p .= '$_ctx->pagination = $core->blog->getPosts($params,true); unset($params);'."\n";
 		$p .= "?>\n";
@@ -1964,5 +1979,4 @@
 		return
 			$p.
-			$this->core->callBehavior("templatePrepareParams","Pagination",$attr,$content).
 			'<?php if ($_ctx->pagination->f(0) > $_ctx->posts->count()) : ?>'.
 			$content.
@@ -2104,5 +2118,7 @@
 		
 		$res = "<?php\n";
-		$res .= $this->core->callBehavior("templatePrepareParams","Comments",$attr,$content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Comments","method" => "blog::getComments"), 
+			$attr,$content);
 		$res .= $p;
 		$res .= '$_ctx->comments = $core->blog->getComments($params); unset($params);'."\n";
@@ -2704,5 +2720,7 @@
 		$res = "<?php\n";
 		$res .= $p;
-		$res .= $this->core->callBehavior("templatePrepareParams","Pings",$attr,$content);
+		$res .= $this->core->callBehavior("templatePrepareParams", 
+			array("tag" => "Pings","method" => "blog::getComments"), 
+			$attr,$content);
 		$res .= '$_ctx->pings = $core->blog->getComments($params); unset($params);'."\n";
 		$res .= "if (\$_ctx->posts !== null) { \$core->blog->withoutPassword(true);}\n";
@@ -2784,5 +2802,5 @@
 	current_mode		CDATA	#IMPLIED	-- tests if current URL mode is the one given in parameter
 	has_tpl			CDATA     #IMPLIED  -- tests if a named template exists
-	has_tag			CDATA     #IMPLIED  -- tests if a named template tag exists (see Tag plugin for code)
+	has_tag			CDATA     #IMPLIED  -- tests if a named template block or value exists
 	blog_id			CDATA     #IMPLIED  -- tests if current blog ID is the one given in parameter
 	comments_active	(0|1)	#IMPLIED	-- test if comments are enabled blog-wide 
@@ -2838,4 +2856,13 @@
 			}
 			$if[] = $sign."\$core->tpl->getFilePath('".addslashes($attr['has_tpl'])."') !== false";
+		}
+		
+		if (isset($attr['has_tag'])) {
+			$sign = 'true';
+			if (substr($attr['has_tag'],0,1) == '!') {
+				$sign = 'false';
+				$attr['has_tag'] = substr($attr['has_tag'],1);
+			}
+			$if[] =  "\$core->tpl->tagExists('".addslashes($attr['has_tag'])."') === ".$sign;
 		}
 		
Index: inc/public/lib.tpl.context.php
===================================================================
--- inc/public/lib.tpl.context.php	(revision 772)
+++ inc/public/lib.tpl.context.php	(revision 839)
@@ -363,5 +363,5 @@
 		if ($_ctx->posts)
 		{
-			$subject = $_ctx->posts->post_excerpt_xhtml.$_ctx->posts->post_content_xhtml.$_ctx->posts->cat_desc;
+			$subject = $_ctx->posts->post_excerpt_xhtml.$_ctx->posts->post_content_xhtml;
 			if (preg_match_all($pattern,$subject,$m) > 0)
 			{
